/* Liste le contenu de l'EEPROM en HEXAdécimal. */

/* Liste le contenu actuel de l'EEPROM sur le Moniteur USB avec possibilité en validant la
   ligne 13 d'éffacer une zone avec des #00.  */

#include <avr/eeprom.h> // Bibliothèque intégrée à l'IDE qui gère les entiers ,les réels ...

int PTR;
char Caractere;

void setup() {
  // Ci-dessous : Possibilité de "purger une zone avec des #00. (Toute l'EEPROM avec ces valeurs de I.
  // for (int I=0; I < 1024; I++) Ecrire_Octet_EEPROM(I, 00);
  Serial.begin(115200);
  Lister_EEPROM(); } 

void loop() {} // La boucle principale ne fait que "tourner en rond" !
  
void Lister_EEPROM() {
  PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC();
  Lister_un_BLOC();Lister_un_BLOC(); }
  
void Lister_un_BLOC() {
  Lister_ENTETE();
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++; } }
  
void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; Serial.print(' ');
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); Serial.print("  ");  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
  
void Lister_ENTETE() {
   Serial.println();
   Serial.println(" ADRS  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");}
   
byte Lire_Octet_EEPROM(int ADRESSE) {return eeprom_read_byte((unsigned char*) ADRESSE);}

void Ecrire_Octet_EEPROM(int ADRESSE, byte Octet) {eeprom_write_byte((unsigned char*) ADRESSE, Octet);}
   
void Lister_OCTET() {
  byte octet = Lire_Octet_EEPROM(PTR);
  if (octet < 16) Serial.print('0'); 
  Serial.print(octet,HEX);
  Serial.print(' '); PTR++; }
